
################################################
sub call_blast_adapter_no_filter
{
    my ($filename, $filename_out, $adaptor_file, $Evector, $path_blast, $blast_version, $syst) = @_;
    my $formatdb = '';
    my $blast = '';

    if ($blast_version eq 'blast')
    {
      $formatdb = '"'.$path_blast.'formatdb" -i '.$adaptor_file.' -p F -o T';
      $blast = '"'.$path_blast.'blastall" -p blastn -d "'.$adaptor_file.'" -i "'.$filename.'" -o "'.$filename_out.'" -T F -e '.$Evector.' -m 8 -F F' ;
    }
    elsif ($syst eq 'win') 
    {
      $formatdb = '"'.$path_blast.'makeblastdb.exe" -dbtype nucl -in "'.$adaptor_file.'" -parse_seqids >blast_message.txt';
      $blast = '"'.$path_blast.'blastn.exe" -task blastn -db "'.$adaptor_file.'" -query "'.$filename.'" -evalue '.$Evector.' -out "'.$filename_out.'" -outfmt 6 -dust no';      
    }
    else
    {
      $formatdb = '"'.$path_blast.'makeblastdb" -dbtype nucl -in "'.$adaptor_file.'" -parse_seqids >blast_message.txt';
      $blast = '"'.$path_blast.'blastn" -task blastn -db "'.$adaptor_file.'" -query "'.$filename.'" -evalue '.$Evector.' -out "'.$filename_out.'" -outfmt 6 -dust no';      
    }
    
    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 

}
################################################
sub call_blast_adapter_no_filter_word_size
{
    my ($filename, $filename_out, $adaptor_file, $Evector, $path_blast, $blast_version, $word_size, $syst) = @_;

    my $formatdb = '';
    my $blast = '';
    
    if ($blast_version eq 'blast')
    {
      $formatdb = '"'.$path_blast.'formatdb" -i "'.$adaptor_file.'" -p F -o T';
      $blast = '"'.$path_blast.'blastall" -p blastn -d "'.$adaptor_file.'" -i "'.$filename.'" -o "'.$filename_out.'" -T F -e '.$Evector.' -m 8 -F F -W '.$word_size;
    }
    elsif ($syst eq 'win') 
    {
      $formatdb = '"'.$path_blast.'makeblastdb.exe" -dbtype nucl -in "'.$adaptor_file.'" -parse_seqids >blast_message.txt';
      $blast = '"'.$path_blast.'blastn.exe" -task blastn -db "'.$adaptor_file.'" -query "'.$filename.'" -evalue '.$Evector.' -word_size '.$word_size.' -out "'.$filename_out.'" -outfmt 6 -dust no';
    }
    else
    {
      $formatdb = '"'.$path_blast.'makeblastdb" -dbtype nucl -in "'.$adaptor_file.'" -parse_seqids >blast_message.txt';
      $blast = '"'.$path_blast.'blastn" -task blastn -db "'.$adaptor_file.'" -query "'.$filename.'" -evalue '.$Evector.' -word_size '.$word_size.' -out "'.$filename_out.'" -outfmt 6 -dust no';
    }
    
#    print "$formatdb\n";
    system $formatdb;

#    print "$blast\n"; 
    system $blast;

}

#################################################################
sub call_blast_query_to_db_soft_mask
{
my ($query_file, $db_file, $filename_out, $Eblast, $blast_path, $blast_version, $syst) = @_;

my $formatdb = '';
my $blast = '';
if ($blast_version eq 'blast')
{
    $formatdb = '"'.$blast_path.'formatdb" -i "'.$db_file.'" -p F -o T';
    $blast = '"'.$blast_path.'blastall" -p blastn -d "'.$db_file.'" -i "'.$query_file.'" -o "'.$filename_out.'" -T F -e '.$Eblast.' -m 8 -F m -U T';
}
elsif ($syst eq 'win') 
{
    $formatdb = '"'.$blast_path.'makeblastdb.exe" -dbtype nucl -in "'.$db_file.'" -parse_seqids >blast_message.txt';
    $blast = '"'.$blast_path.'blastn.exe" -task blastn -db "'.$db_file.'" -query "'.$query_file.'" -out "'.$filename_out.'" -evalue '.$Eblast.' -outfmt 6 -lcase_masking -soft_masking true';
}
else
{
    $formatdb = '"'.$blast_path.'makeblastdb" -dbtype nucl -in "'.$db_file.'" -parse_seqids >blast_message.txt';
    $blast = '"'.$blast_path.'blastn" -task blastn -db "'.$db_file.'" -query "'.$query_file.'" -out "'.$filename_out.'" -evalue '.$Eblast.' -outfmt 6 -lcase_masking -soft_masking true';

}
    system $formatdb;
 #   print "$formatdb\n";

    system $blast;
 #   print "$blast\n"; 
}

############################################################"

sub call_blast_tbl_soft_filter
{
    my ($filename, $filename_out, $Eblast, $blast_path, $blast_version, $syst) = @_;

my $formatdb = '';
my $blast = '';
if ($blast_version eq 'blast')
{
    $formatdb = '"'.$blast_path.'formatdb" -i "'.$filename.'" -p F -o T';
    $blast = '"'.$blast_path.'blastall" -p blastn -d "'.$filename.'" -i "'.$filename.'" -o "'.$filename_out.'" -T F -e '.$Eblast.' -m 8 -F m -U T';
}
elsif ($syst eq 'win') 
{
    $formatdb = '"'.$blast_path.'makeblastdb.exe" -dbtype nucl -in "'.$filename.'" -parse_seqids';
    $blast = '"'.$blast_path.'blastn.exe" -task blastn -db "'.$filename.'" -query "'.$filename.'" -out "'.$filename_out.'" -evalue '.$Eblast.' -outfmt 6 -lcase_masking -soft_masking true';
}
else
{
    $formatdb = '"'.$blast_path.'makeblastdb" -dbtype nucl -in "'.$filename.'" -parse_seqids';
    $blast = '"'.$blast_path.'blastn" -task blastn -db "'.$filename.'" -query "'.$filename.'" -out "'.$filename_out.'" -evalue '.$Eblast.' -outfmt 6 -lcase_masking -soft_masking true';
}
    system $formatdb;
 #   print "$formatdb\n";

    system $blast;
 #   print "$blast\n"; 
}

####################################################

sub copy_files
{
my ($infolder, $outfolder, $syst, $motif) = @_;


unless ( opendir(FOLDER, "$infolder") )
{
      print "Cannot access to folder $infolder\n";
      exit;
}
my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

foreach my $file (@files)
{
  if ($file =~ /$motif/)
  {
    my $copy = '';
    if ($syst eq 'win')
    {
  #    $copy = 'copy "'.$infolder.'\\'.$file.'" "'.$outfolder.'\\'.$file.'"';
     $copy = 'copy "'.$infolder.'\\'.$file.'" "'.$outfolder.'"';

      system $copy; 
    }
    if ($syst eq 'linux')
    {
      $copy = 'cp '.$infolder.'/'.$file.' '.$outfolder;
      system $copy; 
    }
  }
}

}

####################################################

sub copy_one_file
{
my ($source_folder, $file, $dest_folder, $syst) = @_;

    my $copy = '';
    if ($syst eq 'win')
    {
      $file = $source_folder.'\\'.$file;
      $copy = 'copy "'.$file.'" "'.$dest_folder.'"';
      system $copy; 
    }
    if ($syst eq 'linux')
    {
      $file = $source_folder.'/'.$file;
      $copy = 'cp '.$file.' '.$dest_folder;
      system $copy; 
    }

}

#####################################################

sub change_ms_into_lower_case
{
my ($fragment, $ms_pos) = @_;

	my @ms = sort {$a <=> $b} keys %$ms_pos;
	foreach my $ms (@ms)
	{
#	print "$ms;$$ms_pos{$ms}\n";
		$$ms_pos{$ms} =~ /[0-9]+/;
		my $l_ms = $& - $ms +1;
		my $fragment_temp = $fragment;
		my $ms_frag = substr($fragment_temp, $ms-1, $l_ms);
		$ms_frag =~ tr/ACGT/acgt/;
#	print "$ms_frag\n";
		substr($fragment, $ms-1, $l_ms, $ms_frag);
#	print	"$fragment\n";
	}
return $fragment;
}

##################################################################

sub check_param_limits
{
my ($param, $param_limits) = @_;

my $bool = 1;
foreach my $p (keys %$param)
{
  if ($$param_limits{$p}[0] eq 'list')
  {
    my $bool_loc = 0;
    foreach my $v (@{$$param_limits{$p}[2]})
    {
      if ($$param{$p} eq $v)
      {
        $bool_loc = 1;
      }
    }
    if ($bool_loc == 0)
    {
      print "$$param_limits{$p}[1]\n";
      $bool = 0;
    }
  }
  elsif ($$param_limits{$p}[0] eq 'real')
  {
    unless ($$param{$p}>= $$param_limits{$p}[2][0] and $$param{$p}<= $$param_limits{$p}[2][1])
    {
      print "$$param_limits{$p}[1]\n";
      $bool = 0;
    }
  }
  elsif ($$param_limits{$p}[0] eq 'folder')
  {
    if (opendir(F, $$param{$p}))
    {
      closedir (F);    
    }
    else
    {
      print "$$param_limits{$p}[1]\n";
      $bool = 0;
    }
  }
}
if ($bool == 0)
{
  exit;
}
}

####################################################

sub delete_folder
{
my ($folder, $syst) =@_;

if ( opendir(FOLDER, $folder) )
{
	closedir(FOLDER);
	my $rmdir = '';
	if ($syst eq 'win')
	{
		$folder =~ s/\//\\/g;
		$rmdir = 'rmdir /s /q "'.$folder.'"';
	}
	else
	{
		$rmdir = 'rm -r '.$folder;
	}
	system $rmdir;

}

}

######################################################

sub determine_last_folder
{
my ($folder, $motif) = @_;
my $sub_folder = '';
# supposes that folder names are in the format of [a-z0-9]+_date
 
my %list = get_file_folder_list($folder);

foreach my $folder (sort keys %list)
{
  if ($folder =~ /$motif/)
  {
    unless($folder =~ /\./)
    {
      $sub_folder = $folder;
    }
  }
}

$sub_folder = $folder.'/'.$sub_folder;
return $sub_folder;
}

#############################################################

sub find_microsat_gb_motif_def_6
{
    my ($seq, $ms_motif, $ms_pos, $min_single, $min2, $min3, $min4, $min5, $min6) = @_;
    my $bp = length $seq;

    for (my $i= 0; $i < $bp; ++$i)
    {
#	print "$i ";
#Check for motif of single base pair
	my $motif = substr($seq, $i, 1);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	my $j = $i+1;
	if ($j > $bp-1 )
	{
	    next;
	}
	while ( substr($seq, $j, 1) eq $motif )
	{
	    ++$j;
	}
	if ($j - $i > ($min_single-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}

#Check for motif of two base pair
	$motif = substr($seq, $i, 2);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+2;
	if ($j > $bp-2 )
	{
	    next;
	}	
	while ( substr($seq, $j, 2) eq $motif )
	{
	    $j +=2;
	}
	if ($j - $i > (($min2*2)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}

#Check for motif of three base pair
	$motif = substr($seq, $i, 3);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+3;
	if ($j > $bp-3 )
	{
	    next;
	}	
	while ( substr($seq, $j, 3) eq $motif )
	{
	    $j +=3;
	}
	if ($j - $i > (($min3*3)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;   
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}

#Check for motif of 4 base pair
	$motif = substr($seq, $i, 4);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+4;
	if ($j > $bp-4 )
	{
	    next;
	}	
	while ( substr($seq, $j, 4) eq $motif )
	{
	    $j +=4;
	}
	if ($j - $i > (($min4*4)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}

#Check for motif of 5 base pair
	$motif = substr($seq, $i, 5);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+5;
	if ($j > $bp-5 )
	{
	    next;
	}	
	while ( substr($seq, $j, 5) eq $motif )
	{
	    $j +=5;
	}
	if ($j - $i > (($min5*5)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}

#Check for motif of 6 base pair
	$motif = substr($seq, $i, 6);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+6;
	if ($j > $bp-6 )
	{
	    next;
	}	
	while ( substr($seq, $j, 6) eq $motif )
	{
	    $j +=6;
	}
	if ($j - $i > (($min6*6)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;	 
	    next;
	}

    }
    
#    print "\n\n";

}

######################################################

sub get_file_folder_list
{
my ($folder) = @_;
my %list = ();

unless ( opendir(FOLDER, "$folder") )
{
      print "Cannot access to folder $folder\n";
      exit;
}
my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);
foreach my $file (@files)
{
  $list{$file} = '';
}
@files = ();
return %list;
}

##############################################################

sub length_sequences
{
    my ($hach) = @_;
    my @code = keys %$hach;
    my %orig_length  = ();

    foreach my $code (@code)
    {
	$orig_length{$code} = length($$hach{$code});
    }
    return %orig_length;
}

##################################################

sub make_folder
{
my ($syst, $folder_name) = @_;

my $make_folder = ''; 
if ($syst eq 'win')
{
	$make_folder = 'md "'.$folder_name.'"';
#	print "$make_folder\n";
	system $make_folder;
}
elsif ($syst eq 'linux')
{
	$make_folder = 'mkdir '.$folder_name;
	system $make_folder;
}
}

####################################################

sub move_files
{
my ($infolder, $outfolder, $syst, $motif) = @_;


unless ( opendir(FOLDER, "$infolder") )
{
      print "Cannot access to folder $infolder\n";
      exit;
}
my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

foreach my $file (@files)
{
  if ($file =~ /$motif/)
  {
    my $move = '';
    if ($syst eq 'win')
    {
     $move = 'move "'.$infolder.'\\'.$file.'" "'.$outfolder.'"';

      system $move; 
    }
    if ($syst eq 'linux')
    {
      $move = 'mv '.$infolder.'/'.$file.' '.$outfolder;
      system $move; 
    }
  }
}

}


###################################################################"
sub move_files_local
{
my ($source_folder, $dest_folder, $syst) =@_;

my $copy = '';
if ($syst eq 'win')
{
   $copy = 'MOVE "'.$source_folder.'\*.*" "'.$dest_folder.'" >nul';
}
else
{
   $copy = 'mv '.$source_folder.'/*.* '.$dest_folder;
#print "$copy\n";
}

system $copy;
}

#####################################################################
sub open_file_in
{
 my ($filename, $handle) = @_;
 
 unless (open($handle, "$filename"))
 {
     print "Cannot open $filename\n";
     exit;
 }

}
######################################################

sub open_file_and_hach
{
    my ($filename, $first_line) = @_;
#   print "$first_line"; 
	  unless ( open (FILE, "$filename"))
	  { print "Cannot open $filename\n"; exit;}
	  my @data = <FILE>;
    if ($first_line == 0)
    {
	shift (@data);
    }
#	  print "@data";
	  my %hach = txt_into_hachage_1(@data);
	  close FILE;

    return %hach;
}

#############################################################

sub open_file_out
{
 my ($filename, $handle) = @_;
 
 unless (open($handle, ">$filename"))
 {
     print "Cannot open $filename\n";
     exit;
 }

}

###########################################################
sub pool_files
{
my ($file1, $file2, $pool_file) = @_;

open_file_out($pool_file, 'OUT');
open_file_in($file1, 'F1');
while (my $line = <F1>)
{
print OUT "$line";
}
close F1;

open_file_in($file2, 'F2');
while (my $line = <F2>)
{
print OUT "$line";
}
close OUT;
close F2;
}

##############################################################

sub print_hachage
 {
 # print out a hachage in a human readable format
  use warnings;
  use strict;   
   my ($hach) = @_;
   my @cles = keys %$hach;
   my @sorted_keys = sort @cles;

   foreach my $sorted_key (@sorted_keys)
     {
       print "$sorted_key     $$hach{$sorted_key}\n";
     }
  print "\n\n";
  }
  
##################################################################

sub print_heading
{
  print "**********************************************************\n";
  print "QDD version2.1(beta) 28 June 2011\n";
  print "Emese Meglecz, Aix-Marseille University, Marseille, France\n";
  print 'emese.meglecz@univ-provence.fr';
  print "\n";
  print "Plesae, read the Documentation_QDD2.pdf\n";
  print "**********************************************************\n";
}

######################################################

sub read_hach_from_fasta_code_wo_space
{
my ($filename) = @_;
my %seq = ();
	my $i = 0;
	open_file_in($filename, 'IN');
	$/ = ">";
	while (my $seq = <IN>)
	{
		$seq =~ s/>//;
		unless ($seq eq '')
		{
			$seq =~ /.*\n/;
			my $code = $&;
			$seq =~ s/$code//;
			$seq =~ s/\s//g;
			$code =~ s/\s.*//;
			$code =~ s/\s//;
			if (exists $seq{$code})
			{
				++$i;
			}
			$seq{$code} = $seq;	
		}
	}
close IN;
	if ($i>0)
	{
		print "number of sequences with code already used by other sequence: $i\n";
	}
	$/ = "\n";

return %seq;
}
####################################################

sub rename_files
{
my ($infolder, $outfolder, $syst, $motif_source, $motif_dest) = @_;


unless ( opendir(FOLDER, "$infolder") )
{
      print "Cannot access to folder $infolder\n";
      exit;
}
my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

foreach my $file (@files)
{
  if ($file =~ /$motif_source/)
  {
    my $dest_file = $file;
    $dest_file =~ s/$motif_source/$motif_dest/;
    my $move = '';
    if ($syst eq 'win')
    {
     $move = 'move "'.$infolder.'\\'.$file.'" "'.$outfolder.'\\'.$dest_file.'"';

      system $move; 
    }
    if ($syst eq 'linux')
    {
      $move = 'mv '.$infolder.'/'.$file.' '.$outfolder.'/'.$dest_file;
      system $move; 
    }
  }
}

}

##################################################################

sub print_new_set_file
{
my ($param, $set_file) = @_;
open_file_out($set_file, 'SETOUT');

foreach my $p (keys %$param)
{
  print SETOUT "$p=$$param{$p}\n";
}

close SETOUT;
}

##############################################################

sub print_param_menu
{
  my ($param_list, $param) = @_;
  print "\n";
  foreach my $numb (sort {$a<=>$b} keys %$param_list)
  {
    print "$numb : $$param_list{$numb}[1] $$param{$$param_list{$numb}[0]}\n";
  }
  print "\n";
  my $reply = '';
  print "Press enter if all of the settings are correct, or the number of the parameter if you whish to change the settings!\n";
  $reply = <STDIN>;
  return $reply;
}

#######################################################

sub read_set_file_for_command_line
{
my ($param, $set_file, $param_list, $set_file_default) = @_;

read_set_file_for_GUI($param, $set_file, $set_file_default);

my $reply = print_param_menu($param_list, $param);

while ( not ($reply eq "\n"))
{
    chomp $reply;
    {
      if (exists $$param_list{$reply})
      {
        print "$$param_list{$reply}[1]\n";
        $$param{$$param_list{$reply}[0]} = <STDIN>;
        chomp $$param{$$param_list{$reply}[0]};
	    }
	    else
	    {
        print "$reply is not a menu option\n";
	    }
    }
    $reply = print_param_menu($param_list, $param);
}
print_new_set_file($param, $set_file);

}

#######################################################

sub read_set_file_for_GUI
{
  my ($param, $set_file, $set_file_default) = @_;

  unless(open('SET', $set_file))
  {
    print "Cannot open $set_file\n";
  }
  while(my $line = <SET>)
  {
    chomp $line;
    $line =~ s/\s*=\s*/=/;
    $line =~ s/\s*$//;
    $line =~ s/^\s*//;

    my @line = split('=', $line);
    if(exists $$param{$line[0]})
    {
      $$param{$line[0]} = $line[1];
    }
  }
  close SET;

  my $bool = 1;
  foreach my $p (keys %$param)
  {
    if ($$param{$p} eq '')
    {
      print "$p is not defined in $set_file. $set_file_default is used for reding perameters\n";
      $bool = 0;
    }
  }
  unless($bool)
  {
    read_set_file_for_GUI($param, $set_file_default);
  }
}
#######################################################################

sub reverse_complement_loc
{
    my ($temp) = @_;
    my $revcomp = reverse $temp;
    $revcomp =~ tr/ATCGatcg/TAGCtagc/;
    return $revcomp;
}

###########################################################

sub txt_into_hachage_1
{
# reads each line into a hachache. First element before first ';' is the code all other in the lines are values, separates element of the line by ;
    my (@data) = @_;
    my %hach = ();

foreach my $ligne (@data)
{
    
#    $ligne =~ s/\s+/\s/g;
    chomp $ligne;
    $ligne =~ /.+?;/;
    my $code = $&;
    $ligne =~ s/$code//;
    $code =~ s/;//;
    $hach{$code} = $ligne;
}

return %hach;

}

#########################################################

1;
